Class('CustomHomeMenu')
	.extends('AbsolutePanel')

CustomHomeMenu.__init = function( context ){
	
    AbsolutePanel.prototype.__init.apply(this, [0, 0, '100%', '100%']);
	
	this.__resizeHandler = this.fp('__onResize');
	
	Bus.getInstance().on('WINDOW_RESIZE', this.__resizeHandler );
    
    
//     this.__autoremoveHandler = this.fp('autoremove');
    
    
//     Bus.getInstance().on('SET_DASHBOARD_END', this.__autoremoveHandler);
    
    
    this.getContainer()
        .style('background-color', 'white')
        .style('z-index', '999999999999999999');

        
    var wpimage = 
		Path.action('file/preview')
			.addParam('hash', 'logo_sebrae_white' )
			.addParam('height', 35 * window.devicePixelRatio )
			.toURL();
            
            
            
    var wpimage2 = 
		Path.action('file/preview')
			.addParam('hash', 'logo_sebrae_white_2' )
			.addParam('height', 35 * window.devicePixelRatio )
			.toURL();
            
            
            
            
    var analisys_img = 
		Path.action('file/preview')
			.addParam('hash', 'sebrae_mobile_analisys' )
			.addParam('height', 200)
			.toURL();
            
            
            
    var map_img = 
		Path.action('file/preview')
			.addParam('hash', 'sebrae_mobile_map' )
			.addParam('height', 200)
			.toURL();
            
            
    var search_img = 
		Path.action('file/preview')
			.addParam('hash', 'sebrae_mobile_search' )
			.addParam('height', 200)
			.toURL();
            
    
    console.log("__SERVICE__", Bus.getInstance().get('GET_ICON_SERVICE_CONNECTOR')( {type: "FOLDER", "file": "/"} ) );
    
    
    var folders = Bus.getInstance().get('GET_USER_FOLDERS')();
        
    this.append(
//         DOM.create(DOM_TAG_DIV).html( Math.random() ),
        
        DOM.create(DOM_TAG_DIV)
            .style( 'padding', '10px' )
            .style( 'background-color', '#056ab3' )
            .append(
                DOM.create(DOM_TAG_IMG)
                    .attr('src', wpimage)
					.style('height', '35px')
            ),
            
            
        this.__iconsDiv = DOM.create(DOM_TAG_DIV)
            .style('text-align', 'center')
            .append(
            
            
            DOM.create(DOM_TAG_DIV)
                .on('click',  this.rfp('__runIconService',  [Bus.getInstance().get('GET_ICON_SERVICE_CONNECTOR')( {type: "FOLDER", "path": folders[0], icon: 'sebrae_mobile_map', name: 'Análises'} ), {type: "FOLDER", "path": folders[0], icon: 'sebrae_mobile_map', name: 'Análises'}]  )  )
//                 .style('border', "1px solid red")
                .style('color', '#056ab3')
                .style('padding', '20px')
                .style('width', '120px')
                .style('margin', '10px')
                .style('padding-left', '100px')
                .style('text-align', 'left')
                .style('font-size', '30px')
                .style('display', 'inline-block')
                .style('background-size', '76px')
                .style('background-repeat', 'no-repeat')
                .style('background-position', '10px center')
                .style('background-image', 'url('+ analisys_img + ')' )
                .html('Análises'),
                
                
            DOM.create(DOM_TAG_DIV)
                .on('click',  this.rfp('__runIconService',  [Bus.getInstance().get('GET_ICON_SERVICE_CONNECTOR')( {type: "FOLDER", "path": folders[1], icon: 'default_layout_map', name: 'Mapas'} ), {type: "FOLDER", "path": folders[1], icon: 'default_layout_map', name: 'Mapas'}]  )  )
//                 .style('border', "1px solid red")
                .style('color', '#056ab3')
                .style('padding', '20px')
                .style('width', '120px')
                .style('margin', '10px')
                .style('padding-left', '100px')
                .style('text-align', 'left')
                .style('font-size', '30px')
                .style('display', 'inline-block')
                .style('background-size', '76px')
                .style('background-repeat', 'no-repeat')
                .style('background-position', 'left center')
                .style('background-position', '10px center')
                .style('background-image', 'url('+ map_img + ')' )
                .html('Mapas'),
                
                
                
            DOM.create(DOM_TAG_DIV)
                .on('click', this.fp('__runSearchService') )
//                 .style('border', "1px solid red")
                .style('color', '#056ab3')
                .style('padding', '20px')
                .style('width', '120px')
                .style('margin', '10px')
                .style('padding-left', '100px')
                .style('text-align', 'left')
                .style('font-size', '30px')
                .style('display', 'inline-block')
                .style('background-size', '76px')
                .style('background-repeat', 'no-repeat')
                .style('background-position', 'left center')
                .style('background-position', '10px center')
                .style('background-image', 'url('+ search_img + ')' )
                .html('Busca'),
                                
            DOM.create(DOM_TAG_DIV)
                .style('bottom', '0px')
                .style('background-color', '#056ab3' )
                .style('position', 'absolute')
                .style('width', '100%')
                .style('text-align', 'right')
                .append(
                    DOM.create(DOM_TAG_IMG)
                        .attr('src', wpimage2 )
                        .style('margin', '10px')
						.style('height', '35px')
                )
            )
    );
    
    
    
    var ds = new DesktopSwitcher( this.fp('autoremove') );
    
    ds.getContainer()
        .style('position', 'absolute')
        .style('bottom', "10px")
        .style('left', "10px")
    
    this.append( ds );
    
    
    
    setTimeout( this.__resizeHandler, 1);
    
    
//     this.on('insert', this.fp('__appendDesktooSwitcher') );
}



// CustomHomeMenu.__appendDesktooSwitcher = function(){
// //     alert(";)");
//     
//     var d = new DesktopSwitcher();
//     this.append( d );
//     
//     console.log("CustomHomeMenu::__appendDesktooSwitcher", d);
// }


CustomHomeMenu.__runSearchService = function(){

    Bus.getInstance().get('APPEND_APPLICATION_COMPONENT')( new SearchInput() );
	
// 	Bus.getInstance().off('WINDOW_RESIZE', this.__resizeHandler );
    
    this.autoremove();

}


CustomHomeMenu.__onResize = function(){
	
	console.log("CustomHomeMenu.__onResize");
    
    if( this.__iconsDiv.getBOX() ){
	
        var marginTop = ((window.innerHeight - this.__iconsDiv.getBOX().height) / 2) - 67;
        
        this.__iconsDiv.style('margin-top', marginTop + 'px')
        
    }
}



CustomHomeMenu.__runIconService = function( service, config, e ){
	
	
    Bus.getInstance().launch('CLOSE_ALL_WINDOWS');
    
    var handlerOptions = {};
    
    handlerOptions.context = this;
    
    service.activate( handlerOptions, config );
	
// 	Bus.getInstance().off('WINDOW_RESIZE', this.__resizeHandler );

    console.log( this.getContainer() );
    
    this.autoremove();
	
}



CustomHomeMenu.autoremove = function(){
    AbsolutePanel.prototype.autoremove.apply( this, arguments);
    
    Bus.getInstance().off('WINDOW_RESIZE', this.__resizeHandler );
//     Bus.getInstance().off('SET_DASHBOARD_END', this.__autoremoveHandler);
}


