Class('CustomHomeMenuManager')
	.extends('Standart');
	
CustomHomeMenuManager.__init = function(){

	Bus.getInstance().set('SET_WINDOW_OPEN', this.fp('__setWindowOpen') );
	
	Bus.getInstance().on('OPEN_MAIN_SCREEN', this.fp('tryToOpenMainScreen') );
	
    Bus.getInstance().on('SET_DASHBOARD_END', this.fp('tryToOpenMainScreen'));
    
    Bus.getInstance().on('SET_DASHBOARD_END', function(){ console.warn("Dashboard end...") } );
    
	
	this.__status = {};
}


CustomHomeMenuManager.__setWindowOpen = function( mode ){
	
	var currentDesktop = Bus.getInstance().get('GET_CURRENT_DASHBOARD')();
	
	this.__status[ currentDesktop ] = mode;
	
	console.log("SET_WINDOW_OPEN ", currentDesktop, mode);
}

CustomHomeMenuManager.tryToOpenMainScreen = function( e ){
    
    console.log("CustomHomeMenuManager::tryToOpenMainScreen");
    
		
	var currentDesktop = Bus.getInstance().get('GET_CURRENT_DASHBOARD')();
	
	if( Bus.getInstance().get('GET_MAP_STATUS')() ){
        console.info("Fechou por causa do mapa");
        
		return;
    }
	
	if( this.__status[ currentDesktop ] ){
        console.info("Fechou por que existia janela aberta");
        
		return;
    }
    
    
    console.info("Não fechou por que tudo retornou false");
    
    Bus.getInstance().launch('CLOSE_ALL_WINDOWS');
    	
    var cm = new CustomHomeMenu( this );
    
	Bus.getInstance().get('APPEND_APPLICATION_COMPONENT')( new CustomHomeMenu( this ) );
    
    console.log("__THE_CM__", cm );
}
