Class('SearchInput')
    .extends('ContextModalMobile')
	//.extends('AbsolutePanel');

SearchInput.__init = function(){
	
	Bus.getInstance().get('SET_WINDOW_OPEN')( true );
    
    //AbsolutePanel.prototype.__init.apply(this, [0, 0, '100%', '100%']);
    
    ContextModalMobile.prototype.__init.apply(this, [ this.fp('autoremoveFromButton') ]);
    
    
    this.setTitle("Digite aqui para buscar");
    

// s    var wallpaper =  Bus.getInstance().get('GET_CURRENT_WALLPAPER')();
    
    this.getContainer()
        .style('z-index', 99999999999999)
        .style('background-color', 'white');
        
    this.addContainerClass('search_input');
    
    this.append(        
        Form.create()
            .append(
                
                FormLine.create( 100 /*80, 20*/ )
                    .append(
                        this.__textInput = TextInput.create("&nbsp;")/*,*/
//                         Button.create('Fechar', 'bt_close', true)
//                             .addContainerClass('BT_DEFAULT')
//                             .on('click', this.fp('autoremoveFromButton'))
                    )
                    
            )
    );
        
    this.on('insert', this.fp('__inputFocus') );
    
    
    this.__onResizeHandler = this.fp('__onResize');
    
    Bus.getInstance().on('WINDOW_RESIZE',  this.__onResizeHandler );
    


// 	var wpimage = 
// 		Path.action('file/preview')
// 				.addParam('hash', wallpaper)
// 				.addParam('height', 50)
// 				.toURL();
// 				
// 				
// 	var wpimage_final = 
// 		Path.action('file/preview')
// 				.addParam('hash', wallpaper)
// 				.addParam('height', Math.round(document.documentElement.clientHeight * window.devicePixelRatio /** 1.5*/))
// 				.toURL();
// 				
// 	this.getContainer().style({
//         'background-image': 'url('+ wpimage +')',
//         'background-size': 'cover',
//         'background-position': '75% 100%'
//     });
	
	
// 	var img = new Image();
// 	
// 	img.onload = this.rfp('__onPreloadImage', [ wpimage_final ]);
// 	
// 	img.src = wpimage_final;
    
}


SearchInput.__onPreloadImage = function( wpimage_final ){

	this.getContainer().style('background-image', 'url('+ wpimage_final +')');

}



SearchInput.__onResize = function(){
	
	
// 	this.update( 0, "37px", "100%", "calc(100% - 79px)" );
	
	
// 	this.__bcPanel.setSize( window.innerWidth, 34 );
//     
//     this.__sb.updateSizePanel();
//     
// 	this.__sb.getExternalContent().scrollLeft( 1000 );
//     
//     
//     if( this.__listPanel ){
//         this.__listPanel.setSize( this.innerWidth, 100 );
//         this.__listPanel.adjustToParent();
//     }
    

    if( this.__bcPanel ){

        this.__bcPanel.adjustToParent();
        this.__sb.updateSizePanel();
    
    }
    
    
    
}




SearchInput.__verifyRemoveWindow = function(){
	
	if( this.__desktop == Bus.getInstance().get('GET_CURRENT_DASHBOARD')() ){
		this.autoremove();
		Bus.getInstance().off('WINDOW_RESIZE', this.__onResizeHandler);
    }

}


SearchInput.__inputFocus = function(){
    
    this.__noResults();
    
    this.__textInput.focus();
    
    this.__textInput.on('keyup', this.fp('__requestSearch') );
}



SearchInput.__requestSearch = function(){
    
    Bus.getInstance().launch('SEARCH_REQUEST', this, this.__textInput.value() );
    
}




SearchInput.__noResults = function( itens ){
    
    
    
    
    if( this.__bcPanel )
        this.__bcPanel.getContainer().remove();
    
    
    var bc = new Panel(window.innerWidth, 10);
    
    this.__bcPanel = bc;
    
    this.__bcPanel.addContainerClass('bcpanel');
    
    this.append( this.__bcPanel );

    this.__bcPanel.adjustToParent();

}




SearchInput.showItens = function( itens ){
    
    
    if( this.__bcPanel )
        this.__bcPanel.getContainer().remove();
    
    
    var bc = new Panel(window.innerWidth, 10);
    
//     bc.getContainer().style('background-color', 'rgba(255,0,0,0.5)');
    
    this.__bcPanel = bc;
    
    this.__bcPanel.addContainerClass('bcpanel');
	
 	bc.behaviour( this.__sb = new ScrollBehaviour() );
	
// 	bc.append( this.__bcContent = DOM.create(DOM_TAG_DIV).html("carregando...").style("width", '1000px').style('background-color', 'rgba(255,0,0,0.3)') );
	
		
	this.append( bc  );
    
    
//     this.__bc = bc;
    
    
    for(var i = 0; i < itens.length; i++ ){
        
        
        for(var j = 0; j < itens[i].length; j++ ){
            
            
             var service = Bus.getInstance().get('GET_ICON_SERVICE_CONNECTOR')( itens[i][j] );
		
            var image = Path.action('file/preview')
                .addParam('hash', itens[i][j].icon )
                .addParam('height', 60)
                .addParam('width', 60)
                .toURL();
            
            console.log("__ITEM__", itens[i][j]);
        
            bc.append(
                DOM.create(DOM_TAG_DIV)
                    .html( itens[i][j].title || "&nbsp;" )
                    
                    .style("background-repeat", "no-repeat")
                    .style("border-bottom", "1px solid gray")
                    
                    .style("color", "#505050")

                    .style("padding", "20px 0px 20px 33px")
                    
                    .style("background-position", "5px center")
                    
                    .style("background-size", "24px 24px")
                    
     				.style('background-image', 'url('+ image +')')
                    
     				.on('mousedown', this.rfp('__saveMouseDownPosition')  )
      				.on('click', this.rfp('__runIconService', [ service, itens[i][j] ])  )
            );
        
        }
        
    }
    
    this.__bcPanel.adjustToParent();
    this.__sb.updateSizePanel();
    

}



SearchInput.autoremoveFromButton = function(){
	
	Bus.getInstance().get('SET_WINDOW_OPEN')( false );
	
	Bus.getInstance().launch('OPEN_MAIN_SCREEN');
	
	this.autoremove();
	
}

SearchInput.autoremove = function(){

//     this.__textInput.__input.getHTMLElement().blur();
    this.__textInput.blur();
    
    document.body.focus();

	Bus.getInstance().launch('CLOSE_ALL_WINDOWS');
	
    Bus.getInstance().off('WINDOW_RESIZE', this.__onResizeHandler);
	
	Bus.getInstance().get('SET_WINDOW_OPEN')( false );
	
    ContextModalMobile.prototype.autoremove.apply( this, arguments );
	
}



SearchInput.__runIconService = function( service, config, e ){
	
	if( DOM.distance( e.clientX, e.clientY, this.__savedMouseDownX, this.__savedMouseDownY ) < 10 ){
		
		this.autoremove();
		
		var handlerOptions = {};
		
		handlerOptions.context = this;
		
		service.activate( handlerOptions, config );
	}
}




SearchInput.__saveMouseDownPosition = function( e ){
	
	
	this.__savedMouseDownX = e.clientX;
	this.__savedMouseDownY = e.clientY;
	
	console.log("DialogOpenFolder.__saveMouseDownPosition", this.__savedMouseDownX, this.__savedMouseDownY);
	
}
