// "asd123!@#" senha do sql server

Class('ToqMobile')
	.extends('HTMLComponent')
	.events('logged');

ToqMobile.__init = function(){
	HTMLComponent.prototype.__init.apply(this);
    
    DOM.import( document.querySelector(".body_loading") ).remove();    

	DOM.import( document.body )
		.append(
			this.__mainContainer = DOM.create(DOM_TAG_DIV)
				.addClass('__mainContainer')
		);
		
	new ToqBus();
	
	new ClockDaemon();
        
    new HelpTipManager();
	
	this.setAppendContainer( this.__mainContainer );
	
	Bus.getInstance().set('APPEND_APPLICATION_COMPONENT', this.fp('append'));

  	this.launch('insert');
	
	this.append( this.__wp = new Workspace() );
	
	var clock;
    var help;
    var piwindget;
        
    
        
	this.append(
		this.__topBar = TaskBar.create('top', '__topBar')
			.left(
				piwindget = new ProjectInfoWidget( /*atribuir evento on click e mover para libjs*/ )
			)
			.center(
				new Panel()
			)
	);
    
    piwindget.getContainer()
        .on('click', Bus.getInstance().getLauncher('CLOSE_ALL_WINDOWS') )
        .on('click', Bus.getInstance().getLauncher('CLOSE_ALL_MAPS') )
        .on('click', Bus.getInstance().getLauncher('OPEN_MAIN_SCREEN') );
    
	
	new LoginManager( this.fp('__afterLogin'), clock );
        
// 	Bus.getInstance().launch('SET_DASHBOARD', 0);

        setTimeout( Bus.getInstance().getLauncher('SHOW_HELP_TIP', [help]), 2000);
};

ToqMobile.__afterLogin = function( data ){
    
//     new ColorManager();
    
	Bus.getInstance().launch('SET_CURRENT_WALLPAPER', data.wallpaper, data.fixedMark );
	
	this.__instanceManagers( data );
            
// 	Bus.getInstance().launch('NOTIFY', 'Bem vindo ao DATASebrae', 'error', 2000);
	
	new GroupIcon( this );
	
	var legendBar = new LegendBarMobile();
	this.append( legendBar );
	legendBar.setVisible( false );
	
	new DesktopMapManagerMobile();
	
	new AnalisysLayerManager();
	
	
	if( Bus.getInstance().get('HAS_GROUP')("toq.usermenu")  ){
		this.__topBar .right(
			new UserWidget(),
			new SearchWidget()
		);
	}
	else{
		this.__topBar .right(
			new SearchWidget()
		);
	}
	
// 	Bus.getInstance().launch('SET_DASHBOARD', 0);
	Bus.getInstance().launch('SET_USERNAME', data.userName);
	
	this.launch('logged');
	
 	var addResearch = Bus.getInstance().get('ADD_RESEARCH');
	
	addResearch( new SearchCalculator() );
	addResearch( new SearchItens() );
	addResearch( new SearchCoordenada() );
	
	Ajax.load( Path.action('list').addParam('plugins[]', 'UserPlugin').addParam('project', PROJECT ) , 'json')
		.json({
			'Item': {
				'_action': 'list',
				'_filter': ["__OR__",
					['path', '=', data.leftHome],
					['path', '=', data.rightHome]
				],
				'_order': [
					'path'
				],
				'path': null,
				'tag': null,
				'name': null,
				'type': null,
				'icon': null,
				'file': null
			}
		})
		.on('load', this.fp('__addLeftAndRightPanels', [data]))
		.ready();
		
		
	Ajax.load( Path.action('list').addParam('plugins[]', 'UserPlugin').addParam('project', PROJECT ), 'json')
		.json({
			'Item': {
				'_action': 'list',
				'_filter': ["__OR__",
					['folder', '=', 'root/toq/searchers'],
					['folder', '=', 'root/' + Bus.getInstance().get('GET_CURRENT_PROJECT')()  + '/searchers']
				],
				'_order': [
					'path'
				],
				'path': null,
				'tag': null,
				'name': null,
				'type': null,
				'icon': null,
				'file': null
			}
		})
		.on('load', this.fp('__allowSearchers') )
		.ready();
		
		
// 		this.__toolList = Datatable.create('Item', Path.action('list').addParam('plugins[]', 'UserPlugin').addParam('project', PROJECT ) )
//  			.filter(["__OR__",
// 				['folder', '=', 'root/toq/' + this.__source],
// 				['folder', '=', 'root/' + Bus.getInstance().get('GET_CURRENT_PROJECT')()  + '/' + this.__source]
// 			])
	
	this.__folders = [ data.leftHome, data.rightHome ];
	
	Bus.getInstance().set('GET_USER_FOLDERS', this.fp('__getFolders'));
	
// 	Bus.getInstance().launch('SET_DASHBOARD', 0);
// 	Bus.getInstance().launch('OPEN_MAIN_SCREEN');
};


ToqMobile.__getFolders = function(){
	return this.__folders;
}


ToqMobile.__executeURLParameters = function(){
	

  	try{
		var tmp_parms =  Util.decode( URL_PARAMETERS );
		
		var obj = JSON.parse( tmp_parms );
		
		var mv = 1;
		
		for(var i = 0; i < obj.length; i++ ){

			if( i == 3 )
				continue;
			
 			try{
				var service = Bus.getInstance().get('GET_ICON_SERVICE_CONNECTOR')( obj[i] );
				
				service.activate( {x: 40 * mv , y: 40 * mv, context: this}, service );
				
				if( service.type == 'analisys')
					mv++;
 			}
			catch( e ){
				
			}
		}

  	}
 	catch( e ){
		
		
 	}
	
	
	
}


ToqMobile.__allowSearchers = function( data ){
	
	console.log("ToqMobile::__allowSearchers", data);
	
	for(var i = 0; i < data.Item.length; i++ )
		Bus.getInstance().get('GET_ICON_SERVICE_CONNECTOR')( data.Item[i] ).activate();
	
}

ToqMobile.__addLeftAndRightPanels = function( data, userData ){
	
	this.append(

		TaskBar.create('bottom', '__taskbar')
			.right(
				new Icon(
					Bus.getInstance().get('GET_ICON_SERVICE_CONNECTOR')(
						data.Item[1]
					)
				)/*,
		
 				new RemoveWidget()*/
			)
			.left(
				new Icon(
					Bus.getInstance().get('GET_ICON_SERVICE_CONNECTOR')(
						data.Item[0]
					)
				)/*,
		 
		 
				new Icon(
					Bus.getInstance().get('GET_ICON_SERVICE_CONNECTOR')(
						{type: 'SHOW_MAP_LAYOUT', icon: 'default_layout_map', name: 'Layout'}
					)
				)*/
			)
			.center(
				new DesktopSwitcher()
			)/*,*/
			 
//   		new MultipleIconBar('left', userData.leftHome),
//  		new MultipleIconBar('right', userData.rightHome)
	);
	

// 	Bus.getInstance().launch('OPEN_FOLDER', userData.leftHome);
// 	Bus.getInstance().launch('OPEN_FOLDER', userData.rightHome);

    Bus.getInstance().launch('SET_DASHBOARD', 0);
    
    /*var cmm = */new CustomHomeMenuManager();
    Bus.getInstance().launch('OPEN_MAIN_SCREEN')
//     cmm.tryToOpenMainScreen();
    
    
	this.__executeURLParameters();
}

ToqMobile.__instanceManagers = function ( data ){
	
	new ServiceManager();
	
	new IconManager();
	
//  	new FolderManager( [data.leftHome, data.rightHome, ''] );
	
	new DialogManager('mobile');
	
	new SearchManager();
	
	new NotifyManager();
	
	new ColorManager();
	
	new ContextModalManager();
};
