Class('MobileFolderManager')
	.extends('Standart');
	
MobileFolderManager.__init = function( paths ){

 	this.__managedBaseFolders = {};

	for( var i = 0; i < paths.length; i++ ){
		this.__managedBaseFolders[ paths[i] ] = {
			activate: {},
			deactivate: {},
			selected: {},
			opened: '',
		};
	}
	
// 	this.__pathsActivate = {};
// 	this.__pathsDectivate = {};
// 	this.__pathsSelected = {};
// 	this.__openedFolder = '';

	Bus.getInstance().get('REGISTER_ICON_SERVICE_CONNECTOR')(
		[ 
			'FOLDER',
			'MULTIMEDIA_FOLDER'
		],
		this.fp('__getConnector')
	);
	
	Bus.getInstance().on('OPEN_FOLDER', this.fp('__verifyOpenParent') );
}


// MobileFolderManager.__getParentPath = function( path ){
// 	
// 	var parts = path.split('/');
// 	
// 	var finalPath = [];
// 	
// 	for(var i = 0; i < parts.length -1; i++ )
// 		finalPath.push(parts[i]);
// 	
// 	return finalPath.join('/');
// }
// 
// MobileFolderManager.__getPathContext = function( data ){
// 	
// 	for(var prop in this.__managedBaseFolders ){
// 		
// 		var replaced = prop.replace( /\//g , '\\/');
// 		
// 		var expression = new RegExp('^' + replaced, 'g');
// 		
// 		if( expression.test( data ) )
// 			return this.__managedBaseFolders[ prop ];
// 	}
// 	
// 	alert('Falha inesperada, contexto não definido');
// }

MobileFolderManager.__verifyOpenParent = function( data ){
	
// 	var originalPath = data;
// 	
// 	var context = this.__getPathContext( data );
// 	
// 	if( context.selected[ data ] )
// 		data = this.__getParentPath( data );
// 	
// 	this.__saveOpenedFolder( data, context );
// 	this.__launchClosedHandlers( data, context );
// 	this.__launchOpenedHandlers( data, context );
	
// 	if( this.__pathsSelected[ data ] )
// 		data = this.__getParentPath( data );
// 	
// 	this.__saveOpenedFolder( data );
// 	this.__launchClosedHandlers( data );
// 	this.__launchOpenedHandlers( data );
	
// 	até aqui ok da parte do tratador do evento OPEN_FOLDER_COMPLETE
// 	Bus.getInstance().launch('OPEN_FOLDER_COMPLETE', data, originalPath);
	
}

// MobileFolderManager.__launchClosedHandlers = function(data, context){
// 	
// // 	for(var prop in this.__pathsSelected )
// // 		if( this.__pathsDectivate[ prop ] )
// //  			for(var i =0; i < this.__pathsDectivate[prop].length; i++)
// //  				this.__pathsDectivate[ prop ][ i ]();
// 	
// 	for(var prop in context.selected )
// 		if( context.deactivate[ prop ] )
//  			for(var i =0; i < context.deactivate[prop].length; i++)
//  				context.deactivate[ prop ][ i ]();
// }
// 
// MobileFolderManager.__launchOpenedHandlers = function( path, context ){
// // 	this.__pathsSelected = {};
// 	context.selected = {};
// 	
// 	var parts = path.split('/');
// 
// 	var ppart = '';
// 	for(var i = 0; i < parts.length; i++){
// 		
// 		ppart = ppart += parts[i];
// 		
// 		this.__launchOpenedPath( ppart, context );
// // 		this.__pathsSelected[ ppart ] = true;
// 		context.selected[ ppart ] = true;
// 		
// 		ppart += '/' ;
// 	}
// }
// 
// MobileFolderManager.__launchOpenedPath = function( path, context ){
// 	
// // 	if( this.__pathsActivate[ path ] )
// // 		for(var i = 0; i < this.__pathsActivate[path].length; i++ )
// // 			this.__pathsActivate[path][i]();
// 	
// 	if( context.activate[ path ] )
// 		for(var i = 0; i < context.activate[path].length; i++ )
// 			context.activate[path][i]();
// 
// }

MobileFolderManager.__getConnector = function( config ){
	
// 	var context = this.__getPathContext( config.path );

	var ret = {
		'isAlias': true,
		'activate': Bus.getInstance().getLauncher('OPEN_FOLDER', config.path )/*,
		'activateConnector': this.rfp('__registerActivateConnector', [config.path, context]),
		'deactivateConnector': this.rfp('__registerDeactivateConnector', [config.path, context]),
		'status': this.rfp('__getStatus', [ config.path, context ])*/
	};
	
// 	if( config.type == 'MULTIMEDIA_FOLDER'){
// 		ret.remove = this.rfp('__removeMultimediaItem', [config]);
// 	}
	
	return ret;
}

// 
// 
// MobileFolderManager.__removeMultimediaItem = function( config ){
// 
// 	var folder = config.path.split('/');
// 	folder.pop();
// 	folder = folder.join('/');
// 
// 	Ajax.load(Path.action('set'), 'json')
// 		.json({
// 			'Item' : {
// 				'path': config.path,
// 				'_action': 'remove'
// 			}
// 		})
// 		.on('load', Bus.getInstance().getLauncher('REFRESH_FOLDER', [folder]) )
// 		.ready()
// }
// 
// 
// MobileFolderManager.__getStatus = function( path, context ){
// // 	return this.__openedFolder.match( '^' + path );
// 	
// 	return context.opened.match( '^' + path );
// 	
// }
// 
// 
// MobileFolderManager.__saveOpenedFolder = function( path, context ){
// // 	this.__openedFolder = path;
// 	context.opened = path;
// }
// 
// MobileFolderManager.__registerActivateConnector = function( path, context, handler ){
// 	
// // 	if( !this.__pathsActivate[ path ])
// // 		this.__pathsActivate[ path ] = [];
// // 	
// // 	this.__pathsActivate[ path ].push( handler );
// 	
// 	if( !context.activate[ path ])
// 		context.activate[ path ] = [];
// 	
// 	context.activate[ path ].push( handler );
// }
// 
// 
// MobileFolderManager.__registerDeactivateConnector = function( path, context, handler ){
// 	
// // 	if( !this.__pathsDectivate[ path ])
// // 		this.__pathsDectivate[ path ] = [];
// // 	
// // 	this.__pathsDectivate[ path ].push( handler );
// 	
// 	if( !context.deactivate[ path ])
// 		context.deactivate[ path ] = [];
// 	
// 	context.deactivate[ path ].push( handler );
// 	
// }
